'' Serial LCD Test
'' -- for Parallax 2x16 serial display
'' -- by Jon Williams, Parallax
'' -- 25 MAR 2006


CON

  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000
  

OBJ

  lcd : "serial_lcd" 


PUB main | idx1, idx2, char

  if lcd.start(0, 9600, 2)
    lcd.putc(lcd#LcdOn1)                                ' no cursor
    lcd.cls
    lcd.backlight(1)
    lcd.custom(0, @CC0)
    lcd.custom(1, @CC1)
    lcd.custom(2, @CC2)
    lcd.custom(3, @Smiley)

    repeat
      lcd.cls
      waitcnt(cnt + clkfreq / 2)                        ' wait 1/2 sec
      lcd.str(@Msg1)                                    ' print top line

      repeat idx1 from 0 to 15                          ' loop through cols of second message
        repeat idx2 from 0 to 4                         ' loop through animation frames
          lcd.gotoxy(idx1, 1)                           ' move cursor to current position
          lcd.putc(lookupz(idx2 : 0..2,1,Msg2[idx1]))   ' display appropriate character
          waitcnt(cnt + clkfreq / 13)                   ' wait ~75 ms (1000 / 75)
          
      waitcnt(cnt + clkfreq * 3 / 2)                    ' hold 1.5 sec


DAT

  Msg1        byte      " THE PROPELLER  ", 0
  Msg2        byte      "IS VERY COOL!  ", 3, 0

  CC0         byte      $0E, $1F, $1C, $18, $1C, $1F, $0E, $00
  CC1         byte      $0E, $1F, $1F, $18, $1F, $1F, $0E, $00
  CC2         byte      $0E, $1F, $1F, $1F, $1F, $1F, $0E, $00
  Smiley      byte      $00, $0A, $0A, $00, $11, $0E, $06, $00

    